;*******************************************************************************************
;* Mandelbrot Set Fractal, by Paul Nylander, bugman123.com, 6/23/05
;* runtime: 70 seconds
;*******************************************************************************************

;Basic Functions
(defun  (x) (* x x))
(defun add (x1 x2) (if (listp x1) (mapcar 'add x1 x2) (+ x1 x2)))
(defun norm (x) (apply '+ (mapcar ' x)))

;Complex Functions
(defun complex (x y) (list x y))
(defun Re (z) (car z))
(defun Im (z) (cadr z))
(defun CSqr (z) (complex (- ( (Re z)) ( (Im z))) (* 2 (Re z) (Im z))))

(defun Mandelbrot (/ dialog zc z x y nx ny iter)
 (setq dialog (load_dialog "Mandelbrot.dcl"))
 (new_dialog "raster" dialog)
 (mode_tile "accept" 1)
 (start_image "image")
 (setq y 1 nx (dimx_tile "image") ny (dimy_tile "image"))
 (repeat nx (setq x 1)
  (repeat ny
   (setq zc (complex (- (* 3 (/ (- x 1.0) (1- nx))) 2) (- (* 3 (/ (- y 1.0) (1- ny))) 1.5)))
   (setq z (complex 0.0 0.0) iter 0)
   (while (and (< (norm z) 4) (< iter 255)) (setq z (add (CSqr z) zc) iter (1+ iter)))
   (fill_image x y 1 1 iter)
   (setq x (1+ x))
  );r
  (setq y (1+ y))
 );r
 (end_image)
 (action_tile "accept" "(done_dialog)")
 (mode_tile "accept" 0)
 (start_dialog)
 (unload_dialog dialog)
);d
(Mandelbrot)
